(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10215,        318]
NotebookOptionsPosition[      8982,        290]
NotebookOutlinePosition[      9318,        305]
CellTagsIndexPosition[      9275,        302]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"<<", "HepLib`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"9512167e-e677-4f2b-af96-6f425d3f8f14"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "zz"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k1p", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "zz"}], ")"}], 
    RowBox[{"z", "[", "1", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k2p", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "zz"}], ")"}], 
    RowBox[{"z", "[", "2", "]"}]}]}], ";"}]}], "Input",
 CellLabel->"In[88]:=",ExpressionUUID->"35eed38f-ba7d-4219-88bc-8a3f5fd9349b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pm", "=", 
   RowBox[{
    SuperscriptBox["m", "2"], "/", 
    RowBox[{"(", 
     RowBox[{"2", "pp"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k1m", "=", 
   RowBox[{
    SuperscriptBox["K1", "2"], "/", 
    RowBox[{"(", 
     RowBox[{"2", "k1p"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k2m", "=", 
   RowBox[{
    SuperscriptBox["K2", "2"], "/", 
    RowBox[{"(", 
     RowBox[{"2", " ", "k2p"}], ")"}]}]}], ";"}]}], "Input",
 CellLabel->"In[91]:=",ExpressionUUID->"9527929f-4b1e-4d50-9570-e65797aeacc2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pk1", "=", 
   RowBox[{
    RowBox[{"k1p", " ", "pm"}], "+", 
    RowBox[{"k1m", " ", "pp"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pk2", "=", 
   RowBox[{
    RowBox[{"k2p", " ", "pm"}], "+", 
    RowBox[{"k2m", " ", "pp"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k12", "=", 
   RowBox[{
    RowBox[{"k1p", " ", "k2m"}], "+", 
    RowBox[{"k2p", " ", "k1m"}], "-", 
    RowBox[{"K1", " ", "K2"}]}]}], ";"}]}], "Input",
 CellLabel->"In[94]:=",ExpressionUUID->"c0b3ba63-53de-4b1d-b027-b48d09ac9a8e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UF", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "K1", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k1", " ", "p"}], "}"}], ",", 
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SuperscriptBox["k1", "2"], "\[Rule]", "0"}], ",", 
      RowBox[{
       SuperscriptBox["k2", "2"], "\[Rule]", "0"}], ",", 
      RowBox[{
       SuperscriptBox["p", "2"], "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"p", " ", "k1"}], "\[Rule]", "pk1"}], ",", 
      RowBox[{
       RowBox[{"p", " ", "k2"}], "\[Rule]", "pk2"}], ",", 
      RowBox[{
       RowBox[{"k1", " ", "k2"}], "\[Rule]", "k12"}]}], "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"m", "\[Rule]", "1"}], ",", 
      RowBox[{"zz", "\[Rule]", 
       RowBox[{"1", "/", "3"}]}], ",", 
      RowBox[{
       RowBox[{"z", "[", "1", "]"}], "\[Rule]", 
       RowBox[{"1", "/", "6"}]}], ",", 
      RowBox[{
       RowBox[{"z", "[", "2", "]"}], "\[Rule]", 
       RowBox[{"5", "/", "6"}]}]}], "}"}]}], "]"}], "//", "C2M"}]], "Input",
 CellLabel->"In[11]:=",ExpressionUUID->"955559ac-2270-4379-a657-0cd9048ce6ea"],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Pi]", " ", 
           RowBox[{"(", 
            RowBox[{"ep", "-", "1"}], ")"}]}]], " ", 
         SuperscriptBox["\[Pi]", 
          RowBox[{"1", "-", "ep"}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox["m", "2"], ")"}], 
          RowBox[{"-", "ep"}]], " ", 
         SuperscriptBox["zz", 
          RowBox[{
           RowBox[{"2", " ", "ep"}], "-", "1"}]], " ", 
         TemplateBox[{"ep"},
          "Gamma"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"z", "(", "1", ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"zz", "-", "1"}], ")"}]}], ")"}]}], ")"}], 
          RowBox[{"1", "-", 
           RowBox[{"2", " ", "ep"}]}]]}], ",", 
        RowBox[{"-", 
         SuperscriptBox[
          RowBox[{"x", "(", "0", ")"}], "2"]}], ",", 
        RowBox[{"x", "(", "0", ")"}]}], "}"}], 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "ep"}], ",", 
        RowBox[{
         RowBox[{"2", " ", "ep"}], "-", "1"}]}], "}"}]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}], TraditionalForm]], "Output",
 CellLabel->"Out[11]=",ExpressionUUID->"e67594f1-94ea-4ab6-ae55-75536246e2d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UF", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "k1", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k1", "^", "2"}], "-", 
      RowBox[{"m", "^", "2"}]}], "}"}], ",", 
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", "\[Rule]", "1"}], "}"}], ",", "True"}], "]"}], "//", 
  "C2M"}]], "Input",
 CellLabel->"In[97]:=",ExpressionUUID->"0c951ef9-4de5-4419-a470-4718224bed75"],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", 
         SuperscriptBox["\[Pi]", 
          RowBox[{
           FractionBox["3", "2"], "-", "ep"}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox["m", "2"], ")"}], 
          RowBox[{
           FractionBox["1", "2"], "-", "ep"}]], " ", 
         TemplateBox[{RowBox[{"ep", "-", 
             FractionBox["1", "2"]}]},
          "Gamma"]}], ",", 
        SuperscriptBox[
         RowBox[{"x", "(", "0", ")"}], "2"], ",", 
        RowBox[{"x", "(", "0", ")"}]}], "}"}], 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         FractionBox["1", "2"], "-", "ep"}], ",", 
        RowBox[{
         RowBox[{"2", " ", "ep"}], "-", "2"}]}], "}"}]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}], TraditionalForm]], "Output",
 CellLabel->"Out[97]=",ExpressionUUID->"63393e42-aa9e-4c01-9457-730b29b992f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UF", "[", 
   RowBox[{
    RowBox[{"{", "k1", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k1", "^", "2"}], "-", 
      RowBox[{"m", "^", "2"}]}], "}"}], ",", 
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", "\[Rule]", "1"}], "}"}]}], "]"}], "//", "C2M"}]], "Input",
 CellLabel->"In[98]:=",ExpressionUUID->"fad110db-88ac-406e-b1c3-7f6adcbccd7b"],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", 
         SuperscriptBox["\[Pi]", 
          RowBox[{"2", "-", "ep"}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox["m", "2"], ")"}], 
          RowBox[{"1", "-", "ep"}]], " ", 
         TemplateBox[{RowBox[{"ep", "-", "1"}]},
          "Gamma"]}], ",", 
        SuperscriptBox[
         RowBox[{"x", "(", "0", ")"}], "2"], ",", 
        RowBox[{"x", "(", "0", ")"}]}], "}"}], 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"1", "-", "ep"}], ",", 
        RowBox[{
         RowBox[{"2", " ", "ep"}], "-", "3"}]}], "}"}]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}], TraditionalForm]], "Output",
 CellLabel->"Out[98]=",ExpressionUUID->"169e5950-eb0b-4b49-b262-aa62eeaaccac"]
}, Open  ]]
},
WindowSize->{977, 655},
WindowMargins->{{Automatic, 94}, {Automatic, 0}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 129, 2, 30, "Input",ExpressionUUID->"9512167e-e677-4f2b-af96-6f425d3f8f14"],
Cell[690, 24, 492, 15, 73, "Input",ExpressionUUID->"35eed38f-ba7d-4219-88bc-8a3f5fd9349b"],
Cell[1185, 41, 589, 19, 79, "Input",ExpressionUUID->"9527929f-4b1e-4d50-9570-e65797aeacc2"],
Cell[1777, 62, 569, 17, 73, "Input",ExpressionUUID->"c0b3ba63-53de-4b1d-b027-b48d09ac9a8e"],
Cell[CellGroupData[{
Cell[2371, 83, 1203, 35, 56, "Input",ExpressionUUID->"955559ac-2270-4379-a657-0cd9048ce6ea"],
Cell[3577, 120, 1809, 52, 36, "Output",ExpressionUUID->"e67594f1-94ea-4ab6-ae55-75536246e2d5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5423, 177, 524, 16, 30, "Input",ExpressionUUID->"0c951ef9-4de5-4419-a470-4718224bed75"],
Cell[5950, 195, 1294, 37, 46, "Output",ExpressionUUID->"63393e42-aa9e-4c01-9457-730b29b992f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7281, 237, 508, 15, 30, "Input",ExpressionUUID->"fad110db-88ac-406e-b1c3-7f6adcbccd7b"],
Cell[7792, 254, 1174, 33, 42, "Output",ExpressionUUID->"169e5950-eb0b-4b49-b262-aa62eeaaccac"]
}, Open  ]]
}
]
*)

